unit DataModule_gynelog;

interface

uses
  SysUtils, Classes, DB, ADODB, ActnList, Dialogs,
  controls,

  variables_globales,

  jc32_ini,
  jc32_win,

  System.Actions, { Windir }
  System.UITypes

  ;

type
  TDATA_GYNELOG = class(TDataModule)
    source_Patient: TDataSource;
    Connection1: TADOConnection;
    SOURCE_SA: TDataSource;
    ActionList1: TActionList;
    OpenDialog1: TOpenDialog;
    GYNELOG_CONNECT: TAction;
    Open_Tables: TAction;
    ADO_GLB_PATIENT: TADOQuery;
    ADO_SA: TADOQuery;
    GYNELOG_MAJ: TAction;
    GYNELOG_SAVE: TAction;
    procedure GYNELOG_CONNECTExecute(Sender: TObject);
    procedure Open_TablesExecute(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure GYNELOG_MAJExecute(Sender: TObject);
    procedure GYNELOG_SAVEExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  DATA_GYNELOG: TDATA_GYNELOG;

implementation

uses Unit1, StrUtils;


{$R *.dfm}

procedure TDATA_GYNELOG.GYNELOG_CONNECTExecute(Sender: TObject);
var GYNELOG_MDB : string;
begin

Try

{ Si pas de gynelog INI => avorte }
if not FileExists( GetWindowsDir + '\gynelog.ini' ) then exit;

{ evite les err de double ouverture }
if DATA_GYNELOG.Connection1.Connected then DATA_GYNELOG.Connection1.Close;

{ Cherche l'emplacement de la table dans le GYNELOG.INI situ dans le dossier Windows }
GYNELOG_MDB := GetStr('BASES','CheminBaseEasy','', GetWindowsDir + '\gynelog.ini' );


// ---  Si pas trouve ---
If GYNELOG_MDB = '' then exit;

if Not FileExists( GYNELOG_MDB ) then
begin
  form1.caption := 'GYNELOG.MDB non trouv';
  form1.mnu_GYNELOG.Enabled := false;
  exit;
  end;

DATA_GYNELOG.Connection1.ConnectionString :=
	'Provider=Microsoft.Jet.OLEDB.4.0;'+
	'Data Source=' + GYNELOG_MDB + ';' +
	'Persist Security Info=False';

DATA_GYNELOG.Connection1.Connected := True;

Open_Tables.Execute;

except
  		Messagedlg(
  		'Connexion  la Base "GYNELOG.MDB" impossible',	mtError, [mbOK],0) ;
  end;
end;

procedure TDATA_GYNELOG.Open_TablesExecute(Sender: TObject);
begin

DATA_GYNELOG.ADO_GLB_PATIENT.Active := true;
DATA_GYNELOG.ADO_SA.Active := True;

end;

procedure TDATA_GYNELOG.DataModuleCreate(Sender: TObject);
begin

GYNELOG_CONNECT.Execute;

end;

procedure TDATA_GYNELOG.GYNELOG_MAJExecute(Sender: TObject);
var buf : string;
begin

{ CHERCHE LE PATIENT EN COURS => GYNELOG.INI : MRU}
_Patient.CODE := getInt('MRU','PATIENT',5, GetWindowsDir + '\gynelog.ini');

{ POINTE LE DERNIER PATIENT DANS GYNELOG }
if (DATA_GYNELOG.ADO_GLB_PATIENT.Active = True) then Begin
	DATA_GYNELOG.ADO_GLB_PATIENT.Active := False;
  DATA_GYNELOG.ADO_GLB_PATIENT.SQL.Clear;

  DATA_GYNELOG.ADO_GLB_PATIENT.SQL.Add(
    'SELECT [CODE PATIENT], NOM, PRENOM,[DATE NAISSANCE],[NUMERO SECURITE SOCIAL],MEMO,[ADRESSE],[CODE POSTAL],[VILLE],[TEL DOMICILE],[TEL AUTRE] FROM [GLB PATIENT]' );
  DATA_GYNELOG.ADO_GLB_PATIENT.SQL.Add( 'WHERE([CODE PATIENT] = '+ IntToStr(_PATIENT.CODE) +' )' );

  DATA_GYNELOG.ADO_GLB_PATIENT.Active := True;
End;

{ VA CHERCHER LA DATE DES DERNIERES REGLES }
if (DATA_GYNELOG.ADO_SA.Active = True) then Begin
	DATA_GYNELOG.ADO_SA.Active := False;
  DATA_GYNELOG.ADO_SA.SQL.Clear;

  DATA_GYNELOG.ADO_SA.SQL.Add( 'SELECT [CODE PATIENT], [DATE DERNIERES REGLES], [DATE CONCEPTION] FROM [SA GROSSESSE]' );
  DATA_GYNELOG.ADO_SA.SQL.Add( 'WHERE([CODE PATIENT] = '+ IntToStr(_PATIENT.CODE) +' )' );

  DATA_GYNELOG.ADO_SA.Active := True;
End;


if MessageDlg('ATTENTION vous allez Remplacer toutes les donnes administratives de cette fiche'+#13+
'Par les donnes du patient actuellement en cours de consultation dans GYNELOG'+#13+#13+
DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('NOM').AsString + ' ' +
DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('PRENOM').AsString +#13+#13+
'Voulez vous continuer ?', mtConfirmation, mbOKCancel,0) = mrOK then Begin

  { CODE PATIENT GYNELOG = Entier long }
//	Data.Table_Examen.FieldByName('CODE_PATIENT').AsInteger := _Patient.CODE;
	form1.NOM.Text := DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('NOM').AsString + ' ' + DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('PRENOM').AsString;
	form1.DDN.Text := DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('DATE NAISSANCE').AsString;

  { === MATRICULE === }
	buf  := DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('NUMERO SECURITE SOCIAL').AsString;
  { Vide un format vide du type _-__-__-_ }
  if (length(buf) >= 1) and (buf[1] = '_') then buf := '';
  form1.MATRICULE.Text := buf;

  { === ADRESSE === }
	buf := DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('ADRESSE').AsString;
  { Elimine les sauts de ligne }
  if buf <> '' then buf := AnsiReplaceStr(buf,#13+#10, ' - ');
  form1.ADRESSE.Text := Buf;

	form1.VILLE.Text := DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('CODE POSTAL').AsString + ' ' + DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('VILLE').AsString;

  form1.ASSURE.Text := '';
  form1.ASSURE_MATRICULE.Text := '';

End;

end;

procedure TDATA_GYNELOG.GYNELOG_SAVEExecute(Sender: TObject);
begin
{ Sauvegarde le num de scu }

if DATA_GYNELOG.ADO_GLB_PATIENT.State <> dsEdit then Begin
  DATA_GYNELOG.ADO_GLB_PATIENT.Edit;
  DATA_GYNELOG.ADO_GLB_PATIENT.FieldByName('NUMERO SECURITE SOCIAL').AsString := form1.MATRICULE.Text;
  DATA_GYNELOG.ADO_GLB_PATIENT.Post;
End;


end;

end.
